<?php

function add2List($key,$data)
{	global $redis;
	$keylist = $key.':list';
	$keynbentry  = $key.':nbentry';
	$idnewentry  = $redis->incr($keynbentry);
	$keynewentry = $key.':'.$idnewentry;
	$redis->zAdd($keylist, $idnewentry, $idnewentry);
	$redis->set($keynewentry.':data',$data);
	return $keynewentry;
}

function delList_r($key)
{	global $redis;
	$keylist = $key.':list';
	$list = $redis->zRange($keylist, 0, -1, true);
	$redis->delete($key.':nbentry', $key.':data', $key.':html');
	foreach($list as $name => $value) delList_r($key.':'.$value);
	$redis->delete($keylist);
}

/* getFillDesign */

function getList_r($key,$first=1)
{	global $redis;
	$html = $redis->get($key.':html'); if($html !== false) return $html;
	$out = '';
	if(!$first) $out .= '<li>';
	$out .= $redis->get($key.':data');
	$list = $redis->zRange($key.':list', 0, -1, true);
	if(!empty($list))
	{	$out .= '<ul>';
		foreach($list as $name => $value) $out .= getList_r($key.':'.$value,0);
		$out .= '</ul>';
	}
	if(!$first) $out .= '</li>';
	return $out;
}

function saveListHtml($key)
{	global $redis;
	$redis->set($key.':html', getList_r($key));
}

function fn_menu($args)
{	global $redis;
	if( !isset($args[1]) || empty($args[1]) ) return;
	$menukey = redisPrefix.':menu:'.$args[1];
	/*$redis->flushAll();
	add2List($menukey,'<a href="/redis/">Accueil</a>');
	add2List($menukey,'<a href="/redis/ou-nous-trouver">Ou nous trouver</a>');
	add2List($menukey,'<a href="/redis/qui-sommes-nous">Qui sommes nous</a>');
	add2List($menukey,'<a href="/redis/contact">Contact</a>');
	saveListHtml($menukey);*/
	$menu = getList_r($menukey);
	if($menu != '') print $menu;
	else {	//$redis->flushAll();
		add2List($menukey,'<a href="'.site_url.'">Accueil</a>');
		add2List($menukey,'<a href="'.site_url.'ou-nous-trouver">Ou nous trouver</a>');
		add2List($menukey,'<a href="'.site_url.'qui-sommes-nous">Qui sommes nous</a>');
		add2List($menukey,'<a href="'.site_url.'contact">Contact</a>');
		saveListHtml($menukey);
		print getList_r($menukey);
	}
}

?>